package com.lanren.huhu.partner.dao;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.lanren.huhu.partner.domain.PartnerAccount;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.util.List;

@Mapper
public interface PartnerAccountMapper extends BaseMapper<PartnerAccount> {
    int updateBatch(List<PartnerAccount> list);

    int batchInsert(@Param("list") List<PartnerAccount> list);

    int insertOrUpdate(PartnerAccount record);

    int insertOrUpdateSelective(PartnerAccount record);

    /**
     * 按uid查找上级 PartnerAccount
     * @param userId
     * @return
     */
    @Select("SELECT b.* " +
            "FROM partner_invite_relation a " +
            "JOIN partner_account b on a.invite_user_id=b.user_id " +
            "WHERE a.user_id=#{userId}")
    PartnerAccount getParentByUserId(Integer userId);

    /**
     * 按uid查找下级 PartnerAccount
     */
    @Select("SELECT b.* " +
            "FROM partner_invite_relation a " +
            "JOIN partner_account b on a.user_id=b.user_id " +
            "WHERE a.invite_user_id=#{userId}")
    List<PartnerAccount> getChildListByUserId(Integer userId);

    PartnerAccount selectOneForUpdate(Integer userId);

    int updatePartnerRelation(String from, String to);

    PartnerAccount getPartnerAccountByPhone(String phone);
}